#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "CommonFunction.h"
#include "UserImageActor.h"
/*

#define MSG_INACTIVE_HIDE	(WM_USER + 9300)
#define MSG_ACTIVE_PRARENT	(WM_USER + 9301)*/


typedef struct{
	CString strID;
	CString strNickName;
	CString strMsg;

}TRAYPOPINFO;

enum TRAYPOPUP_DRAW_TYPE
{	
	TDT_LOGIN=0,
	TDT_IM_CHAT ,
	TDT_RECEIVE_NOTE ,
	TDT_USEAGE,
	TDT_IPT_EMPLYEE_INFO, //߽  系  .
	TDT_IPT_NO_EMPLYEE,		// ߽  系  .
	TDT_RECEIVE_MAIL
};



class CDuiTrayPopup : public WindowImplBase,
	public IUserImageActorObserver
{
public:
	DUI_DECLARE_MESSAGE_MAP()
	CDuiTrayPopup(CWnd*);

	~CDuiTrayPopup();

	class CWndTrayPopupMgr 
	{
		friend class CDuiTrayPopup;
	public:
		CWndTrayPopupMgr();
		~CWndTrayPopupMgr();
		int GetTotalHeightByIndex(int index);
		

	private:
		CPtrList lstTrayPopup;
		void CWndTrayPopupMgr::AddTrayPopup(CDuiTrayPopup * pTrayPopup);
		void CWndTrayPopupMgr::KillAllTrayPopup();
		void CWndTrayPopupMgr::KillAllIPTTrayPopup();
		void CWndTrayPopupMgr::KillTrayPopup(PVOID pData);

	protected:
	//	virtual LRESULT CWndTrayPopupMgr::WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
		void HandleDeleteTrayPopup(CDuiTrayPopup* pTrayPopup);

	};

	virtual void OnUserImageActor_OnResponseUserImageInfo(CString strUserId);
	LPCTSTR GetWindowClassName() const;
	virtual LRESULT OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	virtual LRESULT OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnMouseMove(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);

	virtual HRESULT HandleCustomMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	
//	void InitWindow();

	void OnPrepare(TNotifyUI& msg);
	
	HWND Create(HWND pParent);
	void SetProfileImage(CString strUserId);
	void UpdateProfileImage(CString strUserId);

	int GetHeight(){return m_nHeight;};

	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	virtual void OnFinalMessage(HWND hWnd);
	void OnTimer(TNotifyUI& msg);
	void SetTimer(UINT nTimerID, UINT uElapse)
	{
		CControlUI* pControl = m_PaintManager.FindControl(_T("bg"));
		ASSERT(pControl);
		if (pControl != NULL)
		{
			m_PaintManager.SetTimer(pControl, nTimerID, uElapse);
		}
	}
	void KillTimer( int nId )
	{
		//::KillTimer(m_hWnd, nId);
		CControlUI* pControl = m_PaintManager.FindControl(_T("bg"));
		if (pControl)
		{
			m_PaintManager.KillTimer(pControl, nId); //, REFRESH_TICKET_TIMER);
		}
	}
/*
protected:
	virtual void PostNcDestroy();*/
private:
	
	LRESULT _OnMsgUserImageUpdated(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	CControlUI* CreateControl(LPCTSTR pstrClass);
	void DoMouseEvent(TEventUI& event);
	void OnLButtonDown();
public:    


	static void ChatShow(TRAYPOPUP_DRAW_TYPE drawType, CString strTitle,  TRAYPOPINFO info, int nShowTimeSec = 5,
		CWnd * pParent = NULL, UINT nNotifyMessage = 0, PVOID pData = NULL);

	static void IPTShow(TRAYPOPUP_DRAW_TYPE drawType,CString strID, CString strName, CString strExt,  CString strPosition, CString strJob, CString strPart, int nShowTimeSec = 60,
		CWnd * pParent = NULL, UINT nNotifyMessage = 0, PVOID pData = NULL);

	static void Show(TRAYPOPUP_DRAW_TYPE drawType, CString strID, CString strTitle,  CString message, int nShowTimeSec = 5,
		CWnd * pParent = NULL, UINT nNotifyMessage = 0, PVOID pData = NULL);
	static void Kill(PVOID pData);
	static void KillAll();
	static void KillAllIPT();
	static void SetTextColor(COLORREF color);
	void DoPrepare();
	void InitWindow();
	static void CalculatePosAndShow(CDuiTrayPopup* pTrayPopup);
	//	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
private:    //Variables

	static CWndTrayPopupMgr m_wndTrayPopupMgr;
	static COLORREF m_color;
    static int m_nIndexArray[10];

	CString m_strMessage;

	TRAYPOPINFO m_trayInfo;
	CFont m_ftNormal;
	CFont m_ftOver;
	CRect m_rcText;
	UINT  m_nNotifyMessage; 
	PVOID m_pData;
	//CRect m_rcDesktopRect;
	CWnd * m_pParentWindow;
	int m_nWidth;
	int m_nHeight;
	int m_nAnimateHeight;
	int m_nAnimateTop;
	int m_nIndex;
	int m_nShowTimeSec;
	BOOL m_bIPT;

	//IPT.
	CString m_strIPTTitle;
	CString m_strName;
	CString m_strExt;
	CString m_strPosition;
	CString m_strJob;
	CString m_strPart;
	HWND			m_hParentWnd;
    CLabelUI *m_pLabelMsg;
	enum TRAYPOPUP_DRAW_TYPE m_trayDrawType;
	HWND m_hWndResetFocus;

};

